#!/bin/sh
# \
exec wishx "$0" "$@"

proc ::new {class} {
	if {[llength [namespace children :: ::$class]] < 1} then {
		namespace eval :: namespace eval $class {variable counter 0}
	}
	set count [namespace eval $class ::get $class counter]
	set name $class$count
	incr count
	namespace eval ::$class variable counter $count
	namespace eval :: namespace eval $name [list variable self $name class $class]
	interp alias {} $name\::get {} ::get $name
	interp alias {} $name\::set {} ::put $name
	interp alias {} $name\::id  {} ::id  $name
	return $name
}

proc ::get {self varName} {
	namespace eval $self eval return \"\$$self\::$varName\"
}

proc ::id {slf} {
	namespace eval $slf [list eval puts stdout \"\$self\"]
}

proc ::put {self varName varValue} {
	namespace eval $self variable $varName \"$varValue\"
}

namespace eval Junk {
	variable counter		0

	namespace export new
}

proc Junk::new {} {
	variable counter

	set name Junk$counter
	incr counter
	namespace eval :: namespace eval $name [list variable self $name]
	interp alias {} $name::get {} Junk::get $name
	interp alias {} $name::id {} Junk::id $name
	interp alias {} $name::set {} Junk::set $name
	return $name
}

proc Junk::get {self varName} {
	namespace eval $self eval return \"\$$self\::$varName\"
}

proc Junk::id {slf} {
	namespace eval ::$slf [list eval puts stdout \"\$self\"]
#	namespace eval $slf [list eval puts stdout \"\$$slf\::self\"]
}

proc Junk::set {self varName varValue} {
	namespace eval ::$self variable $varName \"$varValue\"
}

